# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Testing.V1.Model.DeviceIpBlock do
  @moduledoc """
  A single device IP block

  ## Attributes

  *   `addedDate` (*type:* `GoogleApi.Testing.V1.Model.Date.t`, *default:* `nil`) - The date this block was added to Firebase Test Lab
  *   `block` (*type:* `String.t`, *default:* `nil`) - An IP address block in CIDR notation eg: 34.68.194.64/29
  *   `form` (*type:* `String.t`, *default:* `nil`) - Whether this block is used by physical or virtual devices
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :addedDate => GoogleApi.Testing.V1.Model.Date.t() | nil,
          :block => String.t() | nil,
          :form => String.t() | nil
        }

  field(:addedDate, as: GoogleApi.Testing.V1.Model.Date)
  field(:block)
  field(:form)
end

defimpl Poison.Decoder, for: GoogleApi.Testing.V1.Model.DeviceIpBlock do
  def decode(value, options) do
    GoogleApi.Testing.V1.Model.DeviceIpBlock.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Testing.V1.Model.DeviceIpBlock do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
