# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Testing.V1.Model.DirectAccessVersionInfo do
  @moduledoc """
  Denotes whether Direct Access is supported, and by which client versions. DirectAccessService is currently available as a preview to select developers. You can register today on behalf of you and your team at https://developer.android.com/studio/preview/android-device-streaming

  ## Attributes

  *   `directAccessSupported` (*type:* `boolean()`, *default:* `nil`) - Whether direct access is supported at all. Clients are expected to filter down the device list to only android models and versions which support Direct Access when that is the user intent.
  *   `minimumAndroidStudioVersion` (*type:* `String.t`, *default:* `nil`) - Output only. Indicates client-device compatibility, where a device is known to work only with certain workarounds implemented in the Android Studio client. Expected format "major.minor.micro.patch", e.g. "5921.22.2211.8881706".
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :directAccessSupported => boolean() | nil,
          :minimumAndroidStudioVersion => String.t() | nil
        }

  field(:directAccessSupported)
  field(:minimumAndroidStudioVersion)
end

defimpl Poison.Decoder, for: GoogleApi.Testing.V1.Model.DirectAccessVersionInfo do
  def decode(value, options) do
    GoogleApi.Testing.V1.Model.DirectAccessVersionInfo.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Testing.V1.Model.DirectAccessVersionInfo do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
