# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Testing.V1.Model.Distribution do
  @moduledoc """
  Data about the relative number of devices running a given configuration of the Android platform.

  ## Attributes

  *   `marketShare` (*type:* `float()`, *default:* `nil`) - Output only. The estimated fraction (0-1) of the total market with this configuration.
  *   `measurementTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The time this distribution was measured.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :marketShare => float() | nil,
          :measurementTime => DateTime.t() | nil
        }

  field(:marketShare)
  field(:measurementTime, as: DateTime)
end

defimpl Poison.Decoder, for: GoogleApi.Testing.V1.Model.Distribution do
  def decode(value, options) do
    GoogleApi.Testing.V1.Model.Distribution.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Testing.V1.Model.Distribution do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
