# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Testing.V1.Model.EnvironmentMatrix do
  @moduledoc """
  The matrix of environments in which the test is to be executed.

  ## Attributes

  *   `androidDeviceList` (*type:* `GoogleApi.Testing.V1.Model.AndroidDeviceList.t`, *default:* `nil`) - A list of Android devices; the test will be run only on the specified devices.
  *   `androidMatrix` (*type:* `GoogleApi.Testing.V1.Model.AndroidMatrix.t`, *default:* `nil`) - A matrix of Android devices.
  *   `iosDeviceList` (*type:* `GoogleApi.Testing.V1.Model.IosDeviceList.t`, *default:* `nil`) - A list of iOS devices.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :androidDeviceList => GoogleApi.Testing.V1.Model.AndroidDeviceList.t() | nil,
          :androidMatrix => GoogleApi.Testing.V1.Model.AndroidMatrix.t() | nil,
          :iosDeviceList => GoogleApi.Testing.V1.Model.IosDeviceList.t() | nil
        }

  field(:androidDeviceList, as: GoogleApi.Testing.V1.Model.AndroidDeviceList)
  field(:androidMatrix, as: GoogleApi.Testing.V1.Model.AndroidMatrix)
  field(:iosDeviceList, as: GoogleApi.Testing.V1.Model.IosDeviceList)
end

defimpl Poison.Decoder, for: GoogleApi.Testing.V1.Model.EnvironmentMatrix do
  def decode(value, options) do
    GoogleApi.Testing.V1.Model.EnvironmentMatrix.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Testing.V1.Model.EnvironmentMatrix do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
