# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Testing.V1.Model.IosDeviceFile do
  @moduledoc """
  A file or directory to install on the device before the test starts.

  ## Attributes

  *   `bundleId` (*type:* `String.t`, *default:* `nil`) - The bundle id of the app where this file lives. iOS apps sandbox their own filesystem, so app files must specify which app installed on the device.
  *   `content` (*type:* `GoogleApi.Testing.V1.Model.FileReference.t`, *default:* `nil`) - The source file
  *   `devicePath` (*type:* `String.t`, *default:* `nil`) - Location of the file on the device, inside the app's sandboxed filesystem
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :bundleId => String.t() | nil,
          :content => GoogleApi.Testing.V1.Model.FileReference.t() | nil,
          :devicePath => String.t() | nil
        }

  field(:bundleId)
  field(:content, as: GoogleApi.Testing.V1.Model.FileReference)
  field(:devicePath)
end

defimpl Poison.Decoder, for: GoogleApi.Testing.V1.Model.IosDeviceFile do
  def decode(value, options) do
    GoogleApi.Testing.V1.Model.IosDeviceFile.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Testing.V1.Model.IosDeviceFile do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
