# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Testing.V1.Model.IosTestLoop do
  @moduledoc """
  A test of an iOS application that implements one or more game loop scenarios. This test type accepts an archived application (.ipa file) and a list of integer scenarios that will be executed on the app sequentially.

  ## Attributes

  *   `appBundleId` (*type:* `String.t`, *default:* `nil`) - Output only. The bundle id for the application under test.
  *   `appIpa` (*type:* `GoogleApi.Testing.V1.Model.FileReference.t`, *default:* `nil`) - Required. The .ipa of the application to test.
  *   `scenarios` (*type:* `list(integer())`, *default:* `nil`) - The list of scenarios that should be run during the test. Defaults to the single scenario 0 if unspecified.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :appBundleId => String.t() | nil,
          :appIpa => GoogleApi.Testing.V1.Model.FileReference.t() | nil,
          :scenarios => list(integer()) | nil
        }

  field(:appBundleId)
  field(:appIpa, as: GoogleApi.Testing.V1.Model.FileReference)
  field(:scenarios, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Testing.V1.Model.IosTestLoop do
  def decode(value, options) do
    GoogleApi.Testing.V1.Model.IosTestLoop.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Testing.V1.Model.IosTestLoop do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
