# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Testing.V1.Model.IosVersion do
  @moduledoc """
  An iOS version.

  ## Attributes

  *   `id` (*type:* `String.t`, *default:* `nil`) - An opaque id for this iOS version. Use this id to invoke the TestExecutionService.
  *   `majorVersion` (*type:* `integer()`, *default:* `nil`) - An integer representing the major iOS version. Examples: "8", "9".
  *   `minorVersion` (*type:* `integer()`, *default:* `nil`) - An integer representing the minor iOS version. Examples: "1", "2".
  *   `supportedXcodeVersionIds` (*type:* `list(String.t)`, *default:* `nil`) - The available Xcode versions for this version.
  *   `tags` (*type:* `list(String.t)`, *default:* `nil`) - Tags for this dimension. Examples: "default", "preview", "deprecated".
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :id => String.t() | nil,
          :majorVersion => integer() | nil,
          :minorVersion => integer() | nil,
          :supportedXcodeVersionIds => list(String.t()) | nil,
          :tags => list(String.t()) | nil
        }

  field(:id)
  field(:majorVersion)
  field(:minorVersion)
  field(:supportedXcodeVersionIds, type: :list)
  field(:tags, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Testing.V1.Model.IosVersion do
  def decode(value, options) do
    GoogleApi.Testing.V1.Model.IosVersion.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Testing.V1.Model.IosVersion do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
