# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Testing.V1.Model.ListDeviceSessionsResponse do
  @moduledoc """
  A list of device sessions.

  ## Attributes

  *   `deviceSessions` (*type:* `list(GoogleApi.Testing.V1.Model.DeviceSession.t)`, *default:* `nil`) - The sessions matching the specified filter in the given cloud project.
  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - A token, which can be sent as `page_token` to retrieve the next page. If this field is omitted, there are no subsequent pages.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :deviceSessions => list(GoogleApi.Testing.V1.Model.DeviceSession.t()) | nil,
          :nextPageToken => String.t() | nil
        }

  field(:deviceSessions, as: GoogleApi.Testing.V1.Model.DeviceSession, type: :list)
  field(:nextPageToken)
end

defimpl Poison.Decoder, for: GoogleApi.Testing.V1.Model.ListDeviceSessionsResponse do
  def decode(value, options) do
    GoogleApi.Testing.V1.Model.ListDeviceSessionsResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Testing.V1.Model.ListDeviceSessionsResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
