# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Testing.V1.Model.PerAndroidVersionInfo do
  @moduledoc """
  A version-specific information of an Android model.

  ## Attributes

  *   `deviceCapacity` (*type:* `String.t`, *default:* `nil`) - The number of online devices for an Android version.
  *   `directAccessVersionInfo` (*type:* `GoogleApi.Testing.V1.Model.DirectAccessVersionInfo.t`, *default:* `nil`) - Output only. Identifies supported clients for DirectAccess for this Android version.
  *   `interactiveDeviceAvailabilityEstimate` (*type:* `String.t`, *default:* `nil`) - Output only. The estimated wait time for a single interactive device session using Direct Access.
  *   `versionId` (*type:* `String.t`, *default:* `nil`) - An Android version.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :deviceCapacity => String.t() | nil,
          :directAccessVersionInfo =>
            GoogleApi.Testing.V1.Model.DirectAccessVersionInfo.t() | nil,
          :interactiveDeviceAvailabilityEstimate => String.t() | nil,
          :versionId => String.t() | nil
        }

  field(:deviceCapacity)
  field(:directAccessVersionInfo, as: GoogleApi.Testing.V1.Model.DirectAccessVersionInfo)
  field(:interactiveDeviceAvailabilityEstimate)
  field(:versionId)
end

defimpl Poison.Decoder, for: GoogleApi.Testing.V1.Model.PerAndroidVersionInfo do
  def decode(value, options) do
    GoogleApi.Testing.V1.Model.PerAndroidVersionInfo.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Testing.V1.Model.PerAndroidVersionInfo do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
