# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Testing.V1.Model.ProvidedSoftwareCatalog do
  @moduledoc """
  The currently provided software environment on the devices under test.

  ## Attributes

  *   `androidxOrchestratorVersion` (*type:* `String.t`, *default:* `nil`) - A string representing the current version of AndroidX Test Orchestrator that is used in the environment. The package is available at https://maven.google.com/web/index.html#androidx.test:orchestrator.
  *   `orchestratorVersion` (*type:* `String.t`, *default:* `nil`) - Deprecated: Use AndroidX Test Orchestrator going forward. A string representing the current version of Android Test Orchestrator that is used in the environment. The package is available at https://maven.google.com/web/index.html#com.android.support.test:orchestrator.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :androidxOrchestratorVersion => String.t() | nil,
          :orchestratorVersion => String.t() | nil
        }

  field(:androidxOrchestratorVersion)
  field(:orchestratorVersion)
end

defimpl Poison.Decoder, for: GoogleApi.Testing.V1.Model.ProvidedSoftwareCatalog do
  def decode(value, options) do
    GoogleApi.Testing.V1.Model.ProvidedSoftwareCatalog.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Testing.V1.Model.ProvidedSoftwareCatalog do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
