# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Testing.V1.Model.RoboStartingIntent do
  @moduledoc """
  Message for specifying the start activities to crawl.

  ## Attributes

  *   `launcherActivity` (*type:* `GoogleApi.Testing.V1.Model.LauncherActivityIntent.t`, *default:* `nil`) - An intent that starts the main launcher activity.
  *   `noActivity` (*type:* `GoogleApi.Testing.V1.Model.NoActivityIntent.t`, *default:* `nil`) - Skips the starting activity
  *   `startActivity` (*type:* `GoogleApi.Testing.V1.Model.StartActivityIntent.t`, *default:* `nil`) - An intent that starts an activity with specific details.
  *   `timeout` (*type:* `String.t`, *default:* `nil`) - Timeout in seconds for each intent.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :launcherActivity => GoogleApi.Testing.V1.Model.LauncherActivityIntent.t() | nil,
          :noActivity => GoogleApi.Testing.V1.Model.NoActivityIntent.t() | nil,
          :startActivity => GoogleApi.Testing.V1.Model.StartActivityIntent.t() | nil,
          :timeout => String.t() | nil
        }

  field(:launcherActivity, as: GoogleApi.Testing.V1.Model.LauncherActivityIntent)
  field(:noActivity, as: GoogleApi.Testing.V1.Model.NoActivityIntent)
  field(:startActivity, as: GoogleApi.Testing.V1.Model.StartActivityIntent)
  field(:timeout)
end

defimpl Poison.Decoder, for: GoogleApi.Testing.V1.Model.RoboStartingIntent do
  def decode(value, options) do
    GoogleApi.Testing.V1.Model.RoboStartingIntent.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Testing.V1.Model.RoboStartingIntent do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
