# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Testing.V1.Model.Service do
  @moduledoc """
  The section of an tag. https://developer.android.com/guide/topics/manifest/service-element

  ## Attributes

  *   `intentFilter` (*type:* `list(GoogleApi.Testing.V1.Model.IntentFilter.t)`, *default:* `nil`) - Intent filters in the service
  *   `name` (*type:* `String.t`, *default:* `nil`) - The android:name value
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :intentFilter => list(GoogleApi.Testing.V1.Model.IntentFilter.t()) | nil,
          :name => String.t() | nil
        }

  field(:intentFilter, as: GoogleApi.Testing.V1.Model.IntentFilter, type: :list)
  field(:name)
end

defimpl Poison.Decoder, for: GoogleApi.Testing.V1.Model.Service do
  def decode(value, options) do
    GoogleApi.Testing.V1.Model.Service.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Testing.V1.Model.Service do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
