# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Testing.V1.Model.Shard do
  @moduledoc """
  Output only. Details about the shard.

  ## Attributes

  *   `estimatedShardDuration` (*type:* `String.t`, *default:* `nil`) - Output only. The estimated shard duration based on previous test case timing records, if available.
  *   `numShards` (*type:* `integer()`, *default:* `nil`) - Output only. The total number of shards.
  *   `shardIndex` (*type:* `integer()`, *default:* `nil`) - Output only. The index of the shard among all the shards.
  *   `testTargetsForShard` (*type:* `GoogleApi.Testing.V1.Model.TestTargetsForShard.t`, *default:* `nil`) - Output only. Test targets for each shard. Only set for manual sharding.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :estimatedShardDuration => String.t() | nil,
          :numShards => integer() | nil,
          :shardIndex => integer() | nil,
          :testTargetsForShard => GoogleApi.Testing.V1.Model.TestTargetsForShard.t() | nil
        }

  field(:estimatedShardDuration)
  field(:numShards)
  field(:shardIndex)
  field(:testTargetsForShard, as: GoogleApi.Testing.V1.Model.TestTargetsForShard)
end

defimpl Poison.Decoder, for: GoogleApi.Testing.V1.Model.Shard do
  def decode(value, options) do
    GoogleApi.Testing.V1.Model.Shard.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Testing.V1.Model.Shard do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
