# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Testing.V1.Model.TestEnvironmentCatalog do
  @moduledoc """
  A description of a test environment.

  ## Attributes

  *   `androidDeviceCatalog` (*type:* `GoogleApi.Testing.V1.Model.AndroidDeviceCatalog.t`, *default:* `nil`) - Supported Android devices.
  *   `deviceIpBlockCatalog` (*type:* `GoogleApi.Testing.V1.Model.DeviceIpBlockCatalog.t`, *default:* `nil`) - The IP blocks used by devices in the test environment.
  *   `iosDeviceCatalog` (*type:* `GoogleApi.Testing.V1.Model.IosDeviceCatalog.t`, *default:* `nil`) - Supported iOS devices.
  *   `networkConfigurationCatalog` (*type:* `GoogleApi.Testing.V1.Model.NetworkConfigurationCatalog.t`, *default:* `nil`) - Supported network configurations.
  *   `softwareCatalog` (*type:* `GoogleApi.Testing.V1.Model.ProvidedSoftwareCatalog.t`, *default:* `nil`) - The software test environment provided by TestExecutionService.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :androidDeviceCatalog => GoogleApi.Testing.V1.Model.AndroidDeviceCatalog.t() | nil,
          :deviceIpBlockCatalog => GoogleApi.Testing.V1.Model.DeviceIpBlockCatalog.t() | nil,
          :iosDeviceCatalog => GoogleApi.Testing.V1.Model.IosDeviceCatalog.t() | nil,
          :networkConfigurationCatalog =>
            GoogleApi.Testing.V1.Model.NetworkConfigurationCatalog.t() | nil,
          :softwareCatalog => GoogleApi.Testing.V1.Model.ProvidedSoftwareCatalog.t() | nil
        }

  field(:androidDeviceCatalog, as: GoogleApi.Testing.V1.Model.AndroidDeviceCatalog)
  field(:deviceIpBlockCatalog, as: GoogleApi.Testing.V1.Model.DeviceIpBlockCatalog)
  field(:iosDeviceCatalog, as: GoogleApi.Testing.V1.Model.IosDeviceCatalog)
  field(:networkConfigurationCatalog, as: GoogleApi.Testing.V1.Model.NetworkConfigurationCatalog)
  field(:softwareCatalog, as: GoogleApi.Testing.V1.Model.ProvidedSoftwareCatalog)
end

defimpl Poison.Decoder, for: GoogleApi.Testing.V1.Model.TestEnvironmentCatalog do
  def decode(value, options) do
    GoogleApi.Testing.V1.Model.TestEnvironmentCatalog.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Testing.V1.Model.TestEnvironmentCatalog do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
