# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Testing.V1.Model.TestSpecification do
  @moduledoc """
  A description of how to run the test.

  ## Attributes

  *   `androidInstrumentationTest` (*type:* `GoogleApi.Testing.V1.Model.AndroidInstrumentationTest.t`, *default:* `nil`) - An Android instrumentation test.
  *   `androidRoboTest` (*type:* `GoogleApi.Testing.V1.Model.AndroidRoboTest.t`, *default:* `nil`) - An Android robo test.
  *   `androidTestLoop` (*type:* `GoogleApi.Testing.V1.Model.AndroidTestLoop.t`, *default:* `nil`) - An Android Application with a Test Loop.
  *   `disablePerformanceMetrics` (*type:* `boolean()`, *default:* `nil`) - Disables performance metrics recording. May reduce test latency.
  *   `disableVideoRecording` (*type:* `boolean()`, *default:* `nil`) - Disables video recording. May reduce test latency.
  *   `iosRoboTest` (*type:* `GoogleApi.Testing.V1.Model.IosRoboTest.t`, *default:* `nil`) - An iOS Robo test.
  *   `iosTestLoop` (*type:* `GoogleApi.Testing.V1.Model.IosTestLoop.t`, *default:* `nil`) - An iOS application with a test loop.
  *   `iosTestSetup` (*type:* `GoogleApi.Testing.V1.Model.IosTestSetup.t`, *default:* `nil`) - Test setup requirements for iOS.
  *   `iosXcTest` (*type:* `GoogleApi.Testing.V1.Model.IosXcTest.t`, *default:* `nil`) - An iOS XCTest, via an .xctestrun file.
  *   `testSetup` (*type:* `GoogleApi.Testing.V1.Model.TestSetup.t`, *default:* `nil`) - Test setup requirements for Android e.g. files to install, bootstrap scripts.
  *   `testTimeout` (*type:* `String.t`, *default:* `nil`) - Max time a test execution is allowed to run before it is automatically cancelled. The default value is 5 min.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :androidInstrumentationTest =>
            GoogleApi.Testing.V1.Model.AndroidInstrumentationTest.t() | nil,
          :androidRoboTest => GoogleApi.Testing.V1.Model.AndroidRoboTest.t() | nil,
          :androidTestLoop => GoogleApi.Testing.V1.Model.AndroidTestLoop.t() | nil,
          :disablePerformanceMetrics => boolean() | nil,
          :disableVideoRecording => boolean() | nil,
          :iosRoboTest => GoogleApi.Testing.V1.Model.IosRoboTest.t() | nil,
          :iosTestLoop => GoogleApi.Testing.V1.Model.IosTestLoop.t() | nil,
          :iosTestSetup => GoogleApi.Testing.V1.Model.IosTestSetup.t() | nil,
          :iosXcTest => GoogleApi.Testing.V1.Model.IosXcTest.t() | nil,
          :testSetup => GoogleApi.Testing.V1.Model.TestSetup.t() | nil,
          :testTimeout => String.t() | nil
        }

  field(:androidInstrumentationTest, as: GoogleApi.Testing.V1.Model.AndroidInstrumentationTest)
  field(:androidRoboTest, as: GoogleApi.Testing.V1.Model.AndroidRoboTest)
  field(:androidTestLoop, as: GoogleApi.Testing.V1.Model.AndroidTestLoop)
  field(:disablePerformanceMetrics)
  field(:disableVideoRecording)
  field(:iosRoboTest, as: GoogleApi.Testing.V1.Model.IosRoboTest)
  field(:iosTestLoop, as: GoogleApi.Testing.V1.Model.IosTestLoop)
  field(:iosTestSetup, as: GoogleApi.Testing.V1.Model.IosTestSetup)
  field(:iosXcTest, as: GoogleApi.Testing.V1.Model.IosXcTest)
  field(:testSetup, as: GoogleApi.Testing.V1.Model.TestSetup)
  field(:testTimeout)
end

defimpl Poison.Decoder, for: GoogleApi.Testing.V1.Model.TestSpecification do
  def decode(value, options) do
    GoogleApi.Testing.V1.Model.TestSpecification.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Testing.V1.Model.TestSpecification do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
