# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Testing.V1.Model.TestTargetsForShard do
  @moduledoc """
  Test targets for a shard.

  ## Attributes

  *   `testTargets` (*type:* `list(String.t)`, *default:* `nil`) - Group of packages, classes, and/or test methods to be run for each shard. The targets need to be specified in AndroidJUnitRunner argument format. For example, "package com.my.packages" "class com.my.package.MyClass". The number of test_targets must be greater than 0.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :testTargets => list(String.t()) | nil
        }

  field(:testTargets, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Testing.V1.Model.TestTargetsForShard do
  def decode(value, options) do
    GoogleApi.Testing.V1.Model.TestTargetsForShard.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Testing.V1.Model.TestTargetsForShard do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
